
import java.io.*;
import java.awt.*;

public class Circle extends GObject  {
    public int x,y,r;
    
    
    public Circle() {
        x=100;
        y=100;
        r=50;
        color = Color.BLACK;
        linewidth=1;
    }
    
    public Circle(int x1, int y1, int x2, int y2) {    
        int i;
        if (x1>x2) {
            i=x1;
            x1=x2;
            x2=i;
        }
        if (y1>y2) {
            i=y1;
            y1=y2;
            y2=i;
        }
        color = Color.BLACK;
        color = new Color(
                (int) (Math.random()*255), (int) (Math.random()*255),(int) (Math.random()*255));
        linewidth=1;
        if ( (x2-x1)<(y2-y1) )
            r = (x2-x1) >> 1;
        else
            r = (y2-y1) >> 1;
        x = x1+r;
        y = y1+r;
    }
    
    
    public void draw(Graphics g) {
        g.setColor(color);
        setLineWidth(g);
        g.drawOval(x-r,y-r,  r+r,r+r);
    }
    
    
    
    public String toString() {
        return "Kreis: x:"+x+"  y:"+y;
    }
    
      public boolean showEdit() {
       MyDialogCircle dlg = new MyDialogCircle(null, this);
       return dlg.result;        
    }

    
    
}
