

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;


public class MyDialogCircle extends JDialog implements ActionListener {
    private JLabel labelX= new JLabel("X");
    private JLabel labelY= new JLabel("Y");

    private JLabel labelR= new JLabel("Radius");
    

    private JLabel labelLineWidth= new JLabel("Strichstärke");
    private JLabel labelColor= new JLabel("Farbe");

    private JTextField x= new JTextField();
    private JTextField y= new JTextField();
    private JTextField radius= new JTextField();
    
    private JTextField linewidth= new JTextField();
    private JPanel pColor= new JPanel();
    
    Circle circle;
    
    JButton BnOk;
    JButton BnESC;
    

    public boolean result;  // gibt an, ob Ok oder Esc gedrückt wurde

  public MyDialogCircle( Frame parent, Circle circle) {
   super(parent);
   setModal(true);
   setTitle("Bearbeiten eines Kreies");
   setSize(600,300);
   result=false;
   this.circle = circle;
   setGUI();

   setVisible(true);

  }

  private void setGUI() {
        this.getContentPane().setLayout( new GridBagLayout() );
        
        x.setText( Integer.toString(circle.x) );
        y.setText( Integer.toString(circle.y) );
        radius.setText( Integer.toString(circle.r) );
        linewidth.setText( Double.toString(circle.linewidth) );
        pColor.setBackground(circle.color);
        
       labelX.setFont( new Font("Arial", Font.BOLD,18)  );
       labelY.setFont( new Font("Arial", Font.BOLD,18)  );
       labelR.setFont( new Font("Arial", Font.BOLD,18)  );
       
       labelLineWidth.setFont( new Font("Arial", Font.BOLD,18)  );
       labelColor.setFont( new Font("Arial", Font.BOLD,18)  );

       x.setFont( new Font("Arial", Font.BOLD,18)  );
       y.setFont( new Font("Arial", Font.BOLD,18)  );
       radius.setFont( new Font("Arial", Font.BOLD,18)  );
       
      
       linewidth.setFont( new Font("Arial", Font.BOLD,18)  );
       pColor.setPreferredSize( new Dimension(10,30));
       

      this.getContentPane().add(labelX,
          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(x,
           new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------
      this.getContentPane().add(labelY,
          new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(y,
           new GridBagConstraints(3, 0, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      
      this.getContentPane().add(labelR,
          new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(radius,
           new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------


      this.getContentPane().add(labelLineWidth,
          new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(linewidth,
           new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      this.getContentPane().add(labelColor,
          new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(pColor,
           new GridBagConstraints(3, 2, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      
      // -------------------------------

        JPanel pn = new JPanel();
        pn.setLayout( new FlowLayout() );


        BnOk = new JButton("Ok");
        BnOk.setFont( new Font("Arial", Font.BOLD,18)  );
        pn.add( BnOk);

        BnESC = new JButton("Abbruch");
        BnESC.setFont( new Font("Arial", Font.BOLD,18)  );
        pn.add( BnESC);

        // gleiche Groesse
        BnOk.setPreferredSize( BnESC.getPreferredSize() );
        
        this.getContentPane().add(pn,   
                new GridBagConstraints(0, 3, 4, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(25,0,0,0), 0, 0));

         BnOk.addActionListener(this);
         BnESC.addActionListener(this);
         
         pColor.addMouseListener(new java.awt.event.MouseAdapter() {
          public void mouseClicked(MouseEvent e) {
            chooseColor();
          }
        });
         
  } // setGUI

    @Override
   public void actionPerformed(ActionEvent e) {
     if (e.getSource() == BnOk) {           
      BnOk_click();
     }
     if (e.getSource() == BnESC) {           
      BnESC_click();
     }
    }
  
  private void BnESC_click() {
    result=false;
    setVisible(false);
    dispose();
  }

  private void BnOk_click() {
    result=true;
    // Speichern in variable line
    circle.x = Integer.parseInt(x.getText() );
    circle.y = Integer.parseInt(y.getText() );
    circle.r = Integer.parseInt(radius.getText() );
    circle.linewidth = Float.parseFloat(linewidth.getText() );
    circle.color = pColor.getBackground();
    
    setVisible(false);
    dispose();
  }

 
    private void chooseColor() {
        Color newColor = JColorChooser.showDialog(
             this, "Linienfarbe",
             pColor.getBackground());
       if(newColor != null){
           pColor.setBackground(newColor);
       } 
    }
}

